library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity EROM46b_rw is
    Port ( clk : in std_logic;
	rw : in std_logic;
	begf : in std_logic;
	endf, busy : out std_logic;
	cm : in std_logic_vector(9 downto 0);
	di : in std_logic_vector(7 downto 0);
	do : out std_logic_vector(7 downto 0);
--	mb : inout std_logic_vector(3 downto 0)); --mb(3)=cs, mb(2)=sk, mb(1)=di, mb(0)=do
	mcs, msk, mdo : out std_logic;
	mdi : in std_logic);
end EROM46b_rw;

architecture Behavioral of EROM46b_rw is
	signal dbf, pacc, acc, wtf, cmd, dtf, pendf, rwf : STD_LOGIC;
	signal skct: STD_LOGIC_VECTOR(5 downto 0);	--1/64 >> 1.28us sycle at 50MHz
--	signal bcm: STD_LOGIC_VECTOR(8 downto 0);	--64 words address
	signal bcm: STD_LOGIC_VECTOR(9 downto 0);	--64 words address
--	signal bct: STD_LOGIC_VECTOR(4 downto 0);	--16 bit max
	signal bct: STD_LOGIC_VECTOR(3 downto 0);	--8 bit max
	signal cmct: STD_LOGIC_VECTOR(3 downto 0);	--10 bit command
	signal wtct: STD_LOGIC_VECTOR(12 downto 0);	--13 bit command
	signal bdi, bdo: STD_LOGIC_VECTOR(7 downto 0);	--128 bit data

begin

mcs <= pacc and not wtf;
msk <= skct(5);
endf <= pendf;
process (CLK) 
begin
if CLK='1' and CLK'event then
	dbf <= begf;
	if acc='1' then
		skct <= skct+1;
		if skct="000011" then
			if cmd='1' then
				cmct <= cmct+1;
--				if cmct="1001" then
				if cmct="1010" then
					cmd <= '0';
					if dtf='1' then
						if rwf='1' then
--							mdo <= bdi(15);
--							bdi(15 downto 1) <= bdi(14 downto 0);
--							bct <= "00001";
							mdo <= bdi(7);
							bdi(7 downto 1) <= bdi(6 downto 0);
							bct <= "0001";
						else
							bct <= (others=>'0');
						end if;
					else
						pacc <= '0';
					end if;
				else
--					mdo <= bcm(8);
--					bcm(8 downto 1) <= bcm(7 downto 0);
					mdo <= bcm(9);
					bcm(9 downto 1) <= bcm(8 downto 0);
				end if;
			elsif dtf='1' then
				if bct="1000" then
					wtf <= '1';
					dtf <= '0';
					if rwf='1' then
						wtct <= (others=>'0');
					else
						pacc <= '0';
						do <= bdo;
--						do <= bdo(14 downto 0)&mdi;	--mb(0)=do
					end if;
				else
					bct <= bct+1;
					if rwf='1' then
--						mdo <= bdi(15);
--						bdi(15 downto 1) <= bdi(14 downto 0);
						mdo <= bdi(7);
						bdi(7 downto 1) <= bdi(6 downto 0);
					else
						mdo <= '0';
--						bdo <= bdo(14 downto 0)&mdi;	--mb(0)=do
					end if;
				end if;
			elsif pacc='1' then
				wtf <= '0';
				mdo <= '0';
				if (mdi='1' and wtf='0') or wtct="1111111111111" then	--mb(0)=do
					pacc <= '0';
				else
					wtct <= wtct+1;
				end if;
			else
				acc <= '0';
				pendf <= '1';
				mdo <= '0';
			end if;
		elsif dtf='1' and rwf='0' and pacc='1' and skct="011111" then
--			bdo <= bdo(14 downto 0)&mdi;	--mb(0)=do
			bdo <= bdo(6 downto 0)&mdi;	--mb(0)=do
		end if;
	elsif begf='1' then
		pacc <= '1';
		acc <= '1';
		pendf <= '0';
		cmd <= '1';
--		if cm(8 downto 6)="110" or cm(8 downto 6)="101" then
		if cm(9 downto 7)="110" or cm(9 downto 7)="101" then
			dtf <= '1';
		else
			dtf <= '0';
		end if;
		rwf <= rw;
		skct <= (others=>'0');
		cmct <= (others=>'0');
		bcm <= cm;
		mdo <= '0';
		wtf <= '0';
		bdi <= di;
	else
		pendf <= '0';
	end if;
end if;
end process;

end Behavioral;
