library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
library UNISIM;
use UNISIM.VComponents.all;

entity fifo16_64 is
 port (clk : in std_logic; 
 	up  : in std_logic; 
 	dw  : in std_logic; 
 	ne  : out std_logic; 
 	nf  : out std_logic; 
 	reset  : in std_logic; 
 	di  : in std_logic_vector(63 downto 0); 
 	do  : out std_logic_vector(63 downto 0)); 
end fifo16_64;

architecture Behavioral of fifo16_64 is

 signal we_a : std_logic; 
 signal read_a : std_logic_vector(3 downto 0); 
 signal write_a : std_logic_vector(3 downto 0); 

begin

GEN2:	for i in 0 to 63 generate
uu:RAM16X1D port map (do(i),open,write_a(0),write_a(1),write_a(2),write_a(3),
	di(i),read_a(0),read_a(1),read_a(2),read_a(3),clk,we_a);
end generate;

ne <= '1' when write_a-read_a>=1 else '0';
nf <= '1' when write_a-read_a<"1110" else '0';
we_a <= '1' when up='1' and read_a/=(write_a+1) else '0';

process (clk, up, read_a, write_a, up) 
begin
if (clk'event and clk = '1') then  
	if reset='1' then
		read_a <= (others=>'0');
		write_a <= (others=>'0');
	else 
 		if up='1' and read_a/=(write_a+1) then 
			write_a <= write_a+1;
 		end if; 
 		if dw='1' and read_a/=write_a then
			read_a <= read_a+1;
 		end if; 
 	end if; 
end if; 
 end process;  
end Behavioral;
